<?php

/**
*
* @package BB3Topics
* @copyright (c) 2014 PPK
* @license http://opensource.org/licenses/gpl-2.0.php GNU General Public License v2
*
*
*/

if (!defined('IN_PHPBB'))
{
	exit;
}
if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

$lang = array_merge($lang, array(
	'ACP_BB3TOPICS' => 'BB3Topics',
	'ACP_BB3TOPICS_EXPLAIN' => 'Configuring the display of new topics, messages, announcements, votes, popular, random, discussed, sticky, important topics and unread messages on the forum pages',

	'BB3TOPICS' => 'Forum topics',
	'BB3TOPICS_CONFIG' => 'Settings',
	'ACP_BB3TOPICS_OPTIONS' => 'General settings',
	'ACP_CONFIG_OPTION' => 'option',
	'PERCENT' => '%',
	'DATA_PERIOD_SHORT' => array ('y' => 'g.', 'm' => 'month.', 'd' => 'd.', 'h' => 'hour.', 'i' => 'min.', 's' => 'sec.'),

	'BB3TOPICS_ENABLE' => 'Enable display of forum topics',
	'BB3TOPICS_ENABLE_FONLY' => 'From the forum',
	'BB3TOPICS_ENABLE_EXPLAIN' => 'Three options,
		<br /> <strong> option 1 </strong>: enable on the forum list page,
		<br /> <strong> option 2 </strong>: enable on the topic list page
		<br /> <strong> option 3 </strong>: enable on the message list page
		<br /> From the forum - enable, but when displaying a list of topics or posts on the page, display topics only from the current forum ',
	'BB3TOPICS_OPTIONS' => 'Forum topic options',
	'BB3TOPICS_OPTIONS_EXPLAIN' => 'Four options,
		<br /> <strong> option 1 </strong>: cache data for a specified time,
		<br /> <strong> option 2 </strong>: maximum block height of recent topics, limit the block height of recent topics to this value, the block in this case will be displayed with a scroll bar (0 - do not limit),
		<br /> <strong> option 3 </strong>: minimum block width of recent topics (0 - do not limit),
		<br /> <strong> option 4 </strong>: display the date/time of the message in the specified format (0 - do not display, date in the format <a href = "http://php.net/manual/ru/function.date.php"> php </a>) ',
	'BB3TOPICS_POSITION' => 'Position of the forum topic block',
	'BB3TOPICS_POSITION_EXPLAIN' => 'Three options, by default the topic block is placed horizontally,
		<br /> <strong> option 1 </strong>: display the block on the forum list page in a vertical form,
		<br /> <strong> option 2 </strong>: display a block on the topic list page in a vertical form,
		<br /> <strong> option 3 </strong>: display the block on the message list page in a vertical form ',

	'ACP_BB3TOPICS_TOPICS' => 'New topics',
	'BB3TOPICS_TOPICS_ENABLE' => 'Display new topics',
	'BB3TOPICS_TOPICS_ENABLE_EXPLAIN' => 'New forum topics',
	'BB3TOPICS_TOPICS_EXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_TOPICS_EXCLUDE_FORUM_EXPLAIN' => 'Topics from these forums will not be displayed in this block',
	'BB3TOPICS_TOPICS_OPTIONS' => 'Options for new topics',
	'BB3TOPICS_TOPICS_OPTIONS_EXPLAIN' => 'Five options,
		<br /> <strong> number 1 </strong>: number of topics to display,
		<br /> <strong> number 2 </strong>: length of the topic name,
		<br /> <strong> number 3 </strong>: only include topics with a specified number of views,
		<br /> <strong> number 4 </strong>: include topics with only the specified number of replies (0 - no limit),
		<br /> <strong> number 5 </strong>: highlight in bold the message date no later than the specified value ',
	'BB3TOPICS_TOPICS_VISIBLE' => 'Block display',
	'BB3TOPICS_TOPICS_VISIBLE_EXPLAIN' => 'Three options,
		<br /> <strong> number 1 </strong>: do not display the block on the forum list page,
		<br /> <strong> number 2 </strong>: do not display a block on the topic list page
		<br /> <strong> number 3 </strong>: do not display the block on the message list page ',
	'BB3TOPICS_TOPICS_TRUEEXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_TOPICS_TRUEEXCLUDE_FORUM_EXPLAIN' => 'If Yes, exclude the above forums, otherwise, only include topics from the above forums',

	'ACP_BB3TOPICS_ANNOUNCES' => 'Announcements',
	'BB3TOPICS_ANNOUNCES_ENABLE' => 'Display announcements',
	'BB3TOPICS_ANNOUNCES_ENABLE_EXPLAIN' => 'Forum announcements',
	'BB3TOPICS_ANNOUNCES_EXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_ANNOUNCES_EXCLUDE_FORUM_EXPLAIN' => 'Topics from these forums will not be displayed in this block',
	'BB3TOPICS_ANNOUNCES_OPTIONS' => 'Announcements options',
	'BB3TOPICS_ANNOUNCES_OPTIONS_EXPLAIN' => 'Three options,
		<br /> <strong> number 1 </strong>: number of topics to display,
		<br /> <strong> number 2 </strong>: length of the topic name (0 - no limit),
		<br /> <strong> number 3 </strong>: highlight in bold the message date no later than the specified value ',
	'BB3TOPICS_ANNOUNCES_VISIBLE' => 'Block display',
	'BB3TOPICS_ANNOUNCES_VISIBLE_EXPLAIN' => 'Three options,
		<br /> <strong> number 1 </strong>: do not display the block on the forum list page,
		<br /> <strong> number 2 </strong>: do not display a block on the topic list page
		<br /> <strong> number 3 </strong>: do not display the block on the message list page ',
	'BB3TOPICS_ANNOUNCES_TRUEEXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_ANNOUNCES_TRUEEXCLUDE_FORUM_EXPLAIN' => 'If Yes - exclude the above forums, otherwise, on the contrary, include topics only from the above forums',

	'ACP_BB3TOPICS_VIEWED' => 'Popular topics',
	'BB3TOPICS_VIEWED_ENABLE' => 'Display popular topics',
	'BB3TOPICS_VIEWED_ENABLE_EXPLAIN' => 'Topics with the most views',
	'BB3TOPICS_VIEWED_EXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_VIEWED_EXCLUDE_FORUM_EXPLAIN' => 'Topics from these forums will not be displayed in this block',
	'BB3TOPICS_VIEWED_OPTIONS' => 'Popular topics options',
	'BB3TOPICS_VIEWED_OPTIONS_VIEWSTIME' => 'number of views/topic time',
	'BB3TOPICS_VIEWED_OPTIONS_TIMEVIEWS' => 'topic time/number of views',
	'BB3TOPICS_VIEWED_OPTIONS_EXPLAIN' => 'Four options,
		<br /> <strong> number 1 </strong>: number of topics to display,
		<br /> <strong> number 2 </strong>: length of the topic name (0 - no limit),
		<br /> <strong> number 3 </strong>: sort topics
		<br /> <strong> number 4 </strong>: only include topics with a specified number of views',
	'BB3TOPICS_VIEWED_VISIBLE' => 'Block display',
	'BB3TOPICS_VIEWED_VISIBLE_EXPLAIN' => 'Three options,
		<br /> <strong> number 1 </strong>: do not display the block on the forum list page,
		<br /> <strong> number 2 </strong>: do not display a block on the topic list page
		<br /> <strong> number 3 </strong>: do not display the block on the message list page ',
	'BB3TOPICS_VIEWED_TRUEEXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_VIEWED_TRUEEXCLUDE_FORUM_EXPLAIN' => 'If Yes - exclude the above forums, otherwise vice versa, include topics only from the above forums',

	'ACP_BB3TOPICS_REPLIES' => 'Discussed topics',
	'BB3TOPICS_REPLIES_ENABLE' => 'Display topics discussed',
	'BB3TOPICS_REPLIES_ENABLE_EXPLAIN' => 'Topics with the most replies',
	'BB3TOPICS_REPLIES_EXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_REPLIES_EXCLUDE_FORUM_EXPLAIN' => 'Topics from these forums will not be displayed in this block',
	'BB3TOPICS_REPLIES_OPTIONS' => 'Options for topics discussed',
	'BB3TOPICS_REPLIES_OPTIONS_REPLIESTIME' => 'number of replies/topic time',
	'BB3TOPICS_REPLIES_OPTIONS_TIMEREPLIES' => 'topic time/number of replies',
	'BB3TOPICS_REPLIES_OPTIONS_EXPLAIN' => 'Four options,
		<br /> <strong> number 1 </strong>: number of topics to display,
		<br /> <strong> number 2 </strong>: length of the topic name (0 - no limit),
		<br /> <strong> number 3 </strong>: sort topics
		<br /> <strong> number 4 </strong>: only include topics with a specified number of responses',
	'BB3TOPICS_REPLIES_VISIBLE' => 'Block display',
	'BB3TOPICS_REPLIES_VISIBLE_EXPLAIN' => 'Three options,
		<br /> <strong> number 1 </strong>: do not display the block on the forum list page,
		<br /> <strong> number 2 </strong>: do not display a block on the topic list page
		<br /> <strong> number 3 </strong>: do not display the block on the message list page ',
	'BB3TOPICS_REPLIES_TRUEEXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_REPLIES_TRUEEXCLUDE_FORUM_EXPLAIN' => 'If Yes - exclude the above forums, otherwise, only include topics from the above forums',

	'ACP_BB3TOPICS_VOTES' => 'Polls',
	'BB3TOPICS_VOTES_ENABLE' => 'Display polled topics',
	'BB3TOPICS_VOTES_ENABLE_EXPLAIN' => 'Topics with polls in the forum',
	'BB3TOPICS_VOTES_EXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_VOTES_EXCLUDE_FORUM_EXPLAIN' => 'Topics from these forums will not be displayed in this block',
	'BB3TOPICS_VOTES_OPTIONS' => 'Options for topics with polls',
	'BB3TOPICS_VOTES_OPTIONS_EXPLAIN' => 'Three options,
		<br /> <strong> number 1 </strong>: number of topics to display,
		<br /> <strong> number 2 </strong>: length of the topic name (0 - no limit),
		<br /> <strong> number 3 </strong>: highlight in bold the message date no later than the specified value ',
	'BB3TOPICS_VOTES_VISIBLE' => 'Block display',
	'BB3TOPICS_VOTES_VISIBLE_EXPLAIN' => 'Three options,
		<br /> <strong> number 1 </strong>: do not display the block on the forum list page,
		<br /> <strong> number 2 </strong>: do not display a block on the topic list page
		<br /> <strong> number 3 </strong>: do not display the block on the message list page ',
	'BB3TOPICS_VOTES_TRUEEXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_VOTES_TRUEEXCLUDE_FORUM_EXPLAIN' => 'If Yes, exclude the above forums, otherwise, only include topics from the above forums',

	'ACP_BB3TOPICS_RANDOM' => 'Random topicss',
	'BB3TOPICS_RANDOM_ENABLE' => 'Display random topics',
	'BB3TOPICS_RANDOM_ENABLE_EXPLAIN' => 'Random forum topics',
	'BB3TOPICS_RANDOM_EXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_RANDOM_EXCLUDE_FORUM_EXPLAIN' => 'Topics from these forums will not be displayed in this block',
	'BB3TOPICS_RANDOM_OPTIONS' => 'Random topics options',
	'BB3TOPICS_RANDOM_OPTIONS_EXPLAIN' => 'Five options,
		<br /> <strong> number 1 </strong>: number of topics to display,
		<br /> <strong> number 2 </strong>: length of the topic name (0 - no limit),
		<br /> <strong> number 3 </strong>: only include topics with a specified number of views,
		<br /> <strong> number 4 </strong>: include topics with only the specified number of replies (0 - no limit),
		<br /> <strong> number 5 </strong>: highlight in bold the message date no later than the specified value ',
	'BB3TOPICS_RANDOM_VISIBLE' => 'Block display',
	'BB3TOPICS_RANDOM_VISIBLE_EXPLAIN' => 'Three options,
		<br /> <strong> number 1 </strong>: do not display the block on the forum list page,
		<br /> <strong> number 2 </strong>: do not display a block on the topic list page
		<br /> <strong> number 3 </strong>: do not display the block on the message list page ',
	'BB3TOPICS_RANDOM_TRUEEXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_RANDOM_TRUEEXCLUDE_FORUM_EXPLAIN' => 'If Yes - exclude the above forums, otherwise vice versa, include topics only from the above forums',

	'ACP_BB3TOPICS_PERSONAL' => 'Personal topicss',
	'BB3TOPICS_PERSONAL_ENABLE' => 'Display personal themes',
	'BB3TOPICS_PERSONAL_ENABLE_EXPLAIN' => 'Topics matching certain criteria',
	'BB3TOPICS_PERSONAL_ENABLE_EXPLAIN' => 'The block of personal themes allows you to display a block with a personal (custom) name and content',
	'BB3TOPICS_PERSONAL_EXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_PERSONAL_EXCLUDE_FORUM_EXPLAIN' => 'Topics from these forums will not be displayed in this block',
	'BB3TOPICS_PERSONAL_OPTIONS' => 'Personal topics options',
	'BB3TOPICS_PERSONAL_OPTIONS_TIME' => 'topic date',
	'BB3TOPICS_PERSONAL_OPTIONS_REPLIES' => 'number of replies',
	'BB3TOPICS_PERSONAL_OPTIONS_VIEWS' => 'number of views',
	'BB3TOPICS_PERSONAL_OPTIONS_LASTREPLY' => 'date of last reply',
	'BB3TOPICS_PERSONAL_OPTIONS_LASTVIEW' => 'last viewed date',
	'BB3TOPICS_PERSONAL_OPTIONS_TTYPEASIS' => 'Anyway',
	'BB3TOPICS_PERSONAL_OPTIONS_TTYPEINC' => 'Enable',
	'BB3TOPICS_PERSONAL_OPTIONS_TTYPEEXC' => 'Exclude',
	'BB3TOPICS_PERSONAL_OPTIONS_EXPLAIN' => 'Eleven options,
		<br /> <strong> option 1 </strong>: number of topics to display,
		<br /> <strong> option 2 </strong>: length of the topic name (0 - no limit),
		<br /> <strong> option 3 </strong>: sort topics
		<br /> <strong> option 4 </strong>: regular themes,
		<br /> <strong> option 5 </strong>: sticky topics,
		<br /> <strong> option 6 </strong>: announcements,
		<br /> <strong> option 7 </strong>: important topics,
		<br /> <strong> option 8 </strong>: include topics with only the specified number of views,
		<br /> <strong> option 9 </strong>: include topics with only the specified number of replies (0 - no restrictions),
		<br /> <strong> option 10 </strong>: highlight messages in bold for dates no later than the specified value,
		<br /> <strong> option 11 </strong>: block name or LANG identifier of the name of the block of personal themes',
	'BB3TOPICS_PERSONAL_TOPICS' => 'Topics ID',
	'BB3TOPICS_PERSONAL_TOPICS_EXPLAIN' => 'Display only topics with the specified ID (topic ID separated by commas, for example: 1,56,89,209)',
	'BB3TOPICS_PERSONAL_VISIBLE' => 'Block display',
	'BB3TOPICS_PERSONAL_VISIBLE_EXPLAIN' => 'Three options,
		<br /> <strong> number 1 </strong>: do not display the block on the forum list page,
		<br /> <strong> number 2 </strong>: do not display a block on the topic list page
		<br /> <strong> number 3 </strong>: do not display the block on the message list page ',
	'BB3TOPICS_PERSONAL_TRUEEXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_PERSONAL_TRUEEXCLUDE_FORUM_EXPLAIN' => 'If Yes - exclude the above forums, otherwise, only include topics from the above forums',

	'ACP_BB3TOPICS_STICKY' => 'Sticky topicss',
	'BB3TOPICS_STICKY_ENABLE' => 'Display sticky topics',
	'BB3TOPICS_STICKY_ENABLE_EXPLAIN' => 'Sticky forum topics',
	'BB3TOPICS_STICKY_EXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_STICKY_EXCLUDE_FORUM_EXPLAIN' => 'Topics from these forums will not be displayed in this block',
	'BB3TOPICS_STICKY_OPTIONS' => 'Sticky topics options',
	'BB3TOPICS_STICKY_OPTIONS_EXPLAIN' => 'Three options,
		<br /> <strong> number 1 </strong>: number of topics to display,
		<br /> <strong> number 2 </strong>: length of the topic name (0 - no limit),
		<br /> <strong> number 3 </strong>: highlight in bold the message date no later than the specified value ',
	'BB3TOPICS_STICKY_VISIBLE' => 'Block display',
	'BB3TOPICS_STICKY_VISIBLE_EXPLAIN' => 'Three options,
		<br /> <strong> number 1 </strong>: do not display the block on the forum list page,
		<br /> <strong> number 2 </strong>: do not display a block on the topic list page
		<br /> <strong> number 3 </strong>: do not display the block on the message list page ',
	'BB3TOPICS_STICKY_TRUEEXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_STICKY_TRUEEXCLUDE_FORUM_EXPLAIN' => 'If Yes - exclude the above forums, otherwise, only include topics from the above forums',

	'ACP_BB3TOPICS_GLOBAL' => 'Important topics',
	'BB3TOPICS_GLOBAL_ENABLE' => 'Display important topics',
	'BB3TOPICS_GLOBAL_ENABLE_EXPLAIN' => 'Important forum topics',
	'BB3TOPICS_GLOBAL_EXCLUDE_FORUM' => 'Exclude the specified forums',
	'BB3TOPICS_GLOBAL_EXCLUDE_FORUM_EXPLAIN' => 'Topics from these forums will not be displayed in this block',
	'BB3TOPICS_GLOBAL_OPTIONS' => 'Important topics options',
	'BB3TOPICS_GLOBAL_OPTIONS_EXPLAIN' => 'Three options,
		<br /> <strong> number 1 </strong>: number of topics to display,
		<br /> <strong> number 2 </strong>: length of the topic name (0 - no limit),
		<br /> <strong> number 3 </strong>: highlight in bold the message date no later than the specified value ',
	'BB3TOPICS_GLOBAL_VISIBLE' => 'Block display',
	'BB3TOPICS_GLOBAL_VISIBLE_EXPLAIN' => 'Three options,
		<br /> <strong> number 1 </strong>: do not display the block on the forum list page,
		<br /> <strong> number 2 </strong>: do not display a block on the topic list page
		<br /> <strong> number 3 </strong>: do not display the block on the message list page ',
	'BB3TOPICS_GLOBAL_TRUEEXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_GLOBAL_TRUEEXCLUDE_FORUM_EXPLAIN' => 'If Yes - exclude the above forums, otherwise, include topics only from the above forums',

	'ACP_BB3TOPICS_POSTS' => 'New posts',
	'BB3TOPICS_POSTS_ENABLE' => 'Display new posts',
	'BB3TOPICS_POSTS_EXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_POSTS_EXCLUDE_FORUM_EXPLAIN' => 'Posts from these forums will not be shown in the new posts block',
	'BB3TOPICS_POSTS_OPTIONS' => 'New posts options',
	'BB3TOPICS_POSTS_OPTIONS_EXPLAIN' => 'Five options,
		<br /> <strong> number 1 </strong>: number of topics to display,
		<br /> <strong> number 2 </strong>: length of the topic name,
		<br /> <strong> number 3 </strong>: include topics only with the specified number of views,
		<br /> <strong> number 4 </strong>: include topics only with the specified number of views (0 - no limit),
		<br /> <strong> number 5 </strong>: highlight in bold messages the message date of which no later than the specified value ',
	'BB3TOPICS_POSTS_VISIBLE' => 'Block display',
	'BB3TOPICS_POSTS_VISIBLE_EXPLAIN' => 'Three options,
		<br /> <strong> number 1 </strong>: do not display a block on the forum list page,
		<br /> <strong> number 2 </strong>: do not display the block on the topic list page,
		<br /> <strong> number 3 </strong>: do not display the block on the message list page ',
	'BB3TOPICS_POSTS_TRUEEXCLUDE_FORUM' => 'Exclude specified forums',
	'BB3TOPICS_POSTS_TRUEEXCLUDE_FORUM_EXPLAIN' => 'If Yes, exclude the above forums, otherwise, include posts from topics from only the above forums',

	'ACP_BB3TOPICS_UNREAD' => 'Unread messages',
	'BB3TOPICS_UNREAD_ENABLE' => 'Display unread messages',
	'BB3TOPICS_UNREAD_OPTIONS' => 'Unread messages options',
	'BB3TOPICS_UNREAD_OPTIONS_EXPLAIN' => 'Two options,
		<br /> <strong> number 1 </strong>: number of topics to display,
		<br /> <strong> number 2 </strong>: length of the topic name',
	'BB3TOPICS_UNREAD_VISIBLE' => 'Block display',
	'BB3TOPICS_UNREAD_VISIBLE_EXPLAIN' => 'Three options,
		<br /> <strong> number 1 </strong>: do not display a block on the forum list page,
		<br /> <strong> number 2 </strong>: do not display the block on the topic list page,
		<br /> <strong> number 3 </strong>: do not display the block on the message list page ',

	'LOG_CONFIG_BB3TOPICS_CONFIG' => '<strong> Forum topic settings changed </strong>',

	'ACL_CAT_PPKEXT' => 'PPK extensions',

	'ACL_U_BB3TOPICS' => '<span style = "font-weight:bold;color:#800080;"> BB3Topics </span>: Can see the forum topic block',

));
